property PmyDeck, PmyHands, PmyZij, PmyBet, PmyCredit
global GblackJack, GscreenObject, Gfix

on new me
  set PmyDeck to value(the text of member "cardList" of castLib "data")
  set PmyZij to value(the text of member "zijList" of castLib "data")
  set PmyHands to []
  set PmyBet to 5
  set PmyCredit to Gfix * 5
  repeat with x = 6 to 15
    puppetSprite(x, 1)
    set the locH of sprite x to -5000
    updateStage()
  end repeat
  repeat with x = 24 to 28
    puppetSprite(x, 1)
  end repeat
  return me
end

on deal me
  set x to random(count(PmyDeck))
  set firstCard to getAt(PmyDeck, x)
  deleteAt(PmyDeck, x)
  set x to random(count(PmyDeck))
  set secondCard to getAt(PmyDeck, x)
  deleteAt(PmyDeck, x)
  set hand to new(script "cardHand", firstCard, secondCard, 1)
  add(PmyHands, hand)
  checkHand(hand)
  set x to random(count(PmyDeck))
  set firstCard to getAt(PmyDeck, x)
  deleteAt(PmyDeck, x)
  set x to random(count(PmyDeck))
  set secondCard to getAt(PmyDeck, x)
  deleteAt(PmyDeck, x)
  set hand to new(script "cardHand", firstCard, secondCard, 2)
  add(PmyHands, hand)
  checkHand(hand)
  winLose(me)
end

on hit me
  if PmyHands = [] then
    beep()
  else
    set x to random(count(PmyDeck))
    set firstCard to getAt(PmyDeck, x)
    deleteAt(PmyDeck, x)
    hit(getAt(PmyHands, 1), firstCard)
    winLose(me)
  end if
end

on hitDealer me
  set x to random(count(PmyDeck))
  set firstCard to getAt(PmyDeck, x)
  deleteAt(PmyDeck, x)
  hit(getAt(PmyHands, 2), firstCard)
end

on stay me
  if PmyHands = [] then
    beep()
  else
    repeat while (the PmyTotal of getAt(PmyHands, 2) < 17) and (the PmySoft of getAt(PmyHands, 2) = 0)
      decide(getAt(PmyHands, 2))
    end repeat
    winLoseAbs(me)
  end if
end

on winLose me
  if (the PmyTotal of getAt(PmyHands, 1) = 21) and (the PmyTotal of getAt(PmyHands, 2) = 21) then
    loseBet()
  else
    if the PmyTotal of getAt(PmyHands, 1) = 21 then
      if count(the PmyHand of getAt(PmyHands, 1)) = 2 then
        set PmyBet to 25
      end if
      winbet()
    else
      if the PmyTotal of getAt(PmyHands, 2) = 21 then
        loseBet()
      else
        if the PmyTotal of getAt(PmyHands, 2) > 21 then
          winbet()
        else
          if the PmyTotal of getAt(PmyHands, 1) > 21 then
            loseBet()
          else
            if count(the PmyHand of getAt(PmyHands, 1)) = 5 then
              winbet()
            end if
          end if
        end if
      end if
    end if
  end if
end

on winLoseAbs me
  winLose(me)
  if the PmyTotal of getAt(PmyHands, 1) < the PmyTotal of getAt(PmyHands, 2) then
    loseBet()
  else
    winbet()
  end if
end

on winbet me
  puppetSound(member "vo17.aiff" of castLib "sound")
  set PmyCredit to PmyCredit + PmyBet
  update(the PmyCoin of the PmyATM of GscreenObject, PmyCredit / 5)
  flipCard(getAt(PmyHands, 2))
  beep()
  beep()
  numbers(me)
  set GblackJack to 0
  abort()
end

on loseBet me
  puppetSound(member "vo18.aiff" of castLib "sound")
  set PmyCredit to PmyCredit - PmyBet
  update(the PmyCoin of the PmyATM of GscreenObject, PmyCredit / 5)
  flipCard(getAt(PmyHands, 2))
  beep()
  numbers(me)
  set GblackJack to 0
  abort()
end

on makeBet me, howMuch
  set PmyBet to PmyBet + howMuch
  if PmyBet > PmyCredit then
    set PmyBet to PmyCredit
  end if
  numbers(me)
end

on numbers me
  set temp to PmyCredit + 1000
  set the member of sprite 24 to member (value(char 2 of string(temp)) + 61) of castLib "bjack"
  set the member of sprite 25 to member (value(char 3 of string(temp)) + 61) of castLib "bjack"
  set the member of sprite 26 to member (value(char 4 of string(temp)) + 61) of castLib "bjack"
  set temp to PmyBet + 100
  set the member of sprite 27 to member (value(char 2 of string(temp)) + 61) of castLib "bjack"
  set the member of sprite 28 to member (value(char 3 of string(temp)) + 61) of castLib "bjack"
  updateStage()
end
